program RegExURL;

uses RegExpr;

Const
  cArr: array[0..10] of string =
  (
  'www.google.de',
  'google.de',
  'http://google.de',
  'https://google.de',
  'http://www.google.de',
  'https://www.google.de',
  'https://stackoverflow.com',
  'http://w',
  'https://sdfasdp.ppppppppppp',
  'localhost:8000',
  'http://username:password@example.com'
  );


var
  i: Integer;

function IsValidUrl(aUrl: String): Boolean;
var
  aRegEx: TRegexpr;
  aExpr: String;
begin
  aExpr := '(http(s)?:\/\/.)?(www\.)?[a-zA-Z0-9@:%._\+~#=]{2,256}\.[a-z]{2,6}\b([a-zA-Z0-9@:%_\+.~#?&//=]*)';

  aRegEx := TRegexpr.Create;
  aRegEx.Expression := aExpr;
  aRegEx.ModifierG;
  try
    Result := aRegEx.Exec(aUrl);
  finally
    aRegEx.Free;
  end;
end;

begin

  for i := 0 to High(cArr) do
  begin
    WriteLn(' Is ', cArr[i], ' valid: ', IsValidUrl(cArr[i]));
  end;

  ReadLn;
end.

